#include "GameLib/Framework.h"
#include "GameLib/Input/Manager.h"
#include "GameLib/Input/Manager.h"
#include "GameLib/Math/Matrix34.h"
#include "GameLib/Math/Functions.h"
using namespace GameLib;

#include "Robo.h"
#include "Bullet.h"
#include "Pad.h"
#include "Library/GraphicsDatabase.h"
#include "Library/Model.h"
#include <sstream>
using namespace std;

//{̓t@Cɏo񂾂H
const int Robo::mJumpUpTime = 20; //㏸Ă
const int Robo::mJumpStayTime = 60; //㏸㉺~܂ł̎
const int Robo::mJumpFallTime = 40; //~ɂ鎞
const int Robo::mMoveAccelEndCount = 30; //n߂ĉI܂ł̎
const float Robo::mMaxMoveSpeed = 0.5; //őړx
const float Robo::mJumpHeight = 20.0; //ő卂x
const int Robo::mCameraDelayCount = 10; //WvJn㉽t[œG̕
const float Robo::mCameraDistanceZ = 10.0; //[g납ʂH
const float Robo::mCameraDistanceY = 4.0; //낵
const float Robo::mCameraTargetDistanceZ = 20.0; //_͉[gH
const float Robo::mTurnSpeed = 1.0; //񑬓x
const int Robo::mMaxHitPoint = 100; //őqbgb|Cg
const int Robo::mMaxEnergy = 100; //ő啐|Cg
const int Robo::mEnergyPerBullet = 27; //̏GlM[
const int Robo::mEnergyCharge = 1; //t[܂GlM[̗
const float Robo::mLockOnAngleIn = 10.0; //bNIpx
const float Robo::mLockOnAngleOut = 30.0; //bNIOpx

Robo::Robo( int id ) : 
mPosition( 0.0, 0.0, 0.0 ),
mAngleY( 0.0 ),
mId( id ),
mBulletNumber( 100 ), //߂
mCameraCount( 0 ),
mCount( 0 ),
mVelocity( 0.0, 0.0, 0.0 ),
mMode( MODE_ON_LAND ),
mHitPoint( mMaxHitPoint ),
mEnergy( mMaxEnergy ),
mLockOn( true ){ //Ďn܂̂ōŏ̓bNIĂĂ낤B
	mDatabase = NEW GraphicsDatabase( "robo.txt" );
	mModel = mDatabase->createModel( "robo" );
	mBullets.setSize( mBulletNumber );
}

Robo::~Robo(){
}

void Robo::setPosition( const Vector3& a ){
	mPosition = a;
}

void Robo::setAngleY( float a ){
	mAngleY = a;
}

const Vector3* Robo::getBulletPosition( int i ) const {
	if ( mBullets[ i ].isEmpty() ){
		return 0;
	}else{
		return mBullets[ i ].getPosition();
	}
}

void Robo::update( Robo* enemy ){
	//ł
	if ( mHitPoint <= 0 ){
		return;
	}
	//AI̎vlBvC[̏ꍇ͓͂擾ĕԂ
	bool iJump;
	bool iFire;
	bool iTurn;
	bool iLeft; 
	bool iRight; 
	bool iUp;
	bool iDown; 
	think( &iJump, &iFire, &iTurn, &iLeft, &iRight, &iUp, &iDown );
	//ȉ͂gčs
	const Vector3& enemyPos = *enemy->getPosition();
	++mCount;
	//WvĂH
	float t;
	//͂ɎĂ݂悤BR[h̏d邪ubNPʂŌ΃VvɂȂB
	//ʂ̏Ƃǂ炪ǂׂĂ݂悤B
	switch ( mMode ){
		case MODE_JUMP_UP:
			//J肫ĂȂȂJ]p
			if ( mCameraCount < mCameraDelayCount ){
				mAngleY += mAngleVelocityY;
				++mCameraCount;
			}
			//㏸
			t = mJumpHeight / static_cast< float >( mJumpUpTime );
			mVelocity.y = t;
			if ( !iJump ){ //Wv͂Ȃ̂ŉ~ɕω
				mMode = MODE_JUMP_FALL;
				mCount = 0;
			}else if ( mCount >= mJumpUpTime ){ //㏸I
				mMode = MODE_JUMP_STAY; 
				mCount = 0;
			}
			mVelocity.x = mVelocity.z = 0.0; //X,Zړ𖕎E
			break;
		case MODE_JUMP_STAY:
			//J肫ĂȂȂJ]p
			if ( mCameraCount < mCameraDelayCount ){
				mAngleY += mAngleVelocityY;
				++mCameraCount;
			}
			mVelocity.y = 0.0;
			if ( !iJump ){ //Wv͂Ȃ̂ŉ~ɕω
				mMode = MODE_JUMP_FALL;
				mCount = 0;
			}else if ( mCount >= mJumpStayTime ){ //~
				mMode = MODE_JUMP_FALL;
				mCount = 0;
			}
			break;
		case MODE_JUMP_FALL:
			//J肫ĂȂȂJ]p
			if ( mCameraCount < mCameraDelayCount ){
				mAngleY += mAngleVelocityY;
				++mCameraCount;
			}
			//~
			t = mJumpHeight / static_cast< float >( mJumpFallTime );
			mVelocity.y = -t;
			//ڒn͍ŏIIɂ͏Փˏł̂łł͂ȂB
			break;
		case MODE_ON_LAND:
			if ( iJump ){
				mMode = MODE_JUMP_UP;
				mCount = 0;
				mCameraCount = 0;

				//G̕ɌB
				Vector3 dir;
				dir.setSub( enemyPos, mPosition ); //G
				//Ypxatan2( x, z )
				t = GameLib::Math::atan2( dir.x, dir.z );
				//180xȏ㍷+-360xċt
				if ( t - mAngleY > 180.f ){
					t -= 360.f;
				}else if ( mAngleY - t > 180.f ){
					t += 360.f;
				}
				mAngleVelocityY = ( t - mAngleY ) / static_cast< float >( mCameraDelayCount );
			}else if ( iTurn ){
				turn( iLeft, iRight ); //R[hȂ̂Ŋ֐ɔ΂
			}else{
				move( iLeft, iRight, iUp, iDown ); //R[hȂ̂Ŋ֐ɔ΂
			}
			mVelocity.y = 0.f;
			break;
	}
	//牺͏ՓˏƂ̌ɂȂB
	mPosition += mVelocity;
	if ( mPosition.y < 0.f ){
		mPosition.y = 0.f;
		mMode = MODE_ON_LAND;
	}
	//퐶
	if ( iFire ){
		//㏸A~͌ĂȂ
		if ( ( mMode != MODE_JUMP_FALL ) && ( mMode != MODE_JUMP_UP ) ){
			//GlM[ĂH
			if ( mEnergy >= mEnergyPerBullet ){
				//󂫕T
				for ( int i = 0; i < mBulletNumber; ++i ){
					if ( mBullets[ i ].isEmpty() ){
						const char* name = ( mId == 0 ) ? "bulletB" : "bulletR";
						mBullets[ i ].create(
							mDatabase, 
							name, 
							mPosition,
							15.f,
							mAngleY,
							mLockOn );
						mEnergy -= mEnergyPerBullet;
						break;
					}
				}
			}
		}
	}
	//XV
	for ( int i = 0; i < mBulletNumber; ++i ){
		if ( !mBullets[ i ].isEmpty() ){
			mBullets[ i ].update( enemyPos );
			//Փˏ
			Vector3 t;
			t.setSub( *mBullets[ i ].getPosition(), enemyPos );
			if ( t.squareLength() < 4.f ){
				enemy->setDamage( 1 ); //1_炵Ă݂B
				mBullets[ i ].die(); //e܂B
			}
		}
	}
	//GlM[`[W
	mEnergy += mEnergyCharge;
	if ( mEnergy > mMaxEnergy ){
		mEnergy = mMaxEnergy;
	}
	//bNI
	//܂͊px𑪂Ă݂悤B
	//px͉ő邩HAςB
	Vector3 toEnemy;
	toEnemy.setSub( enemyPos, mPosition );
	Vector3 myDir( 0.f, 0.f, -1.f );
	Matrix34 m;
	m.setRotationY( mAngleY + 180.f );
	m.mul( &myDir, myDir );
	toEnemy *= 1.f / toEnemy.length(); //1
	float dotProduct = toEnemy.dot( myDir );
	if ( dotProduct > 1.f ){ //덷̂1z邩ȂB
		dotProduct = 1.f;
	}else if ( dotProduct < -1.f ){
		dotProduct = -1.f;
	}
	//pxɒƁA
	float angle = GameLib::Math::acos( dotProduct );
	if ( mLockOn ){
		//bNIĂȂO邩ǂׂ
		if ( angle > mLockOnAngleOut ){
			mLockOn = false;
		}
	}else{
		//邩ǂׂ
		if ( angle < mLockOnAngleIn ){
			mLockOn = true;
		}
	}
	//Ō̏ԂModelɃZbg
	mModel->setAngle( Vector3( 0.f, mAngleY, 0.f ) );
	mModel->setPosition( mPosition );
}

void Robo::think(
bool* jump,
bool* fire,
bool* turn,
bool* left,
bool* right,
bool* up,
bool* down ) const {
	Pad* pad = Pad::instance();
	if ( mId == 0 ){ //vC[
		*jump = pad->isOn( Pad::JUMP, mId );
		*fire = pad->isTriggered( Pad::FIRE, mId );
		*turn = pad->isOn( Pad::TURN, mId );
		*left = pad->isOn( Pad::LEFT, mId );
		*right = pad->isOn( Pad::RIGHT, mId );
		*up = pad->isOn( Pad::UP, mId );
		*down = pad->isOn( Pad::DOWN, mId );
	}else{ //AI
		//n
		//bNIĂȂ΃Wv
		*jump = !mLockOn;
		//e͌Ă邾B
		*fire = true;
		//͂Ȃ
		*turn = false;
		//ړ͕ϐ̂ʓ|Ȃ̂łȂB
		*left = *right = *up = *down = false;
	}
}

void Robo::turn( bool left, bool right ){
	if ( left ){
		mAngleY += mTurnSpeed;
		if ( mAngleY > 180.f ){ //-PIPIɂ߂
			mAngleY -= 360.f;
		}
	}
	if ( right ){
		mAngleY -= mTurnSpeed;
		if ( mAngleY < -180.f ){ //-PIPIɂ߂
			mAngleY += 360.0;
		}
	}
}

void Robo::move( bool left, bool right, bool up, bool down ){
	//ړB܂_lȂxo
	Vector3 move( 0.f, 0.f, 0.f );
	if ( up ){
		move.z = -1.f;
	}
	if ( down ){
		move.z = 1.f;
	}
	if ( left ){
		move.x = -1.f;
	}
	if ( right ){
		move.x = 1.f;
	}
	//ĉ]
	Matrix34 m;
	m.setRotationY( mAngleY + 180.f );
	m.mul( &move, move );

	//~܂ĂȂb͑BKɉĂ邾
	if ( mVelocity.x == 0.f && mVelocity.z == 0.f ){
		//ɂ鎞Ԃōő呬x1t[̉xoB
		float accel = mMaxMoveSpeed / static_cast< float >( mMoveAccelEndCount );
		mVelocity.setMul( move, accel );
	}else{ //łɓĂꍇ
		if ( move.x == 0.f && move.z == 0.f ){ //ړ[
			mVelocity.set( 0.f, 0.f, 0.f ); //ړ͂Ƃ܂B
		}else{
			//łɓĂꍇȂʓ|łB
			//45x]Ƀ[ȂƂ̂̓XgXB
			//AȗxƕȂ[蒼vɂB

			//90xȏ̃^[ȂUx0ɂB
			//Q[邪AтѓȂ犵͎ז낤B
			//90xȏ̃^[Ȃ猻xƉ̓ς}CiX̂͂
			float dp = mVelocity.dot( move );
			if ( dp <= 0.f ){
				mVelocity.set( 0.f, 0.f, 0.f );
			}else{ //90x
				//݂̈ړxƐȐ̂ݎo
				//́AړPʃxN^Ƃ̓ςAړPʃxN^ɂ΂B
				//ړPʃxN^EAxxN^VƂāAVxxN^V'Ȃ킿s
				//V' = dot(V,E) * E
				//̎AE͈ړxN^MgE=M/|M|Ə邩A
				//V' = dot(V,M) * M / ( |M|^2 )
				//APʃxN^ۂ̕B|M||M|^2̕vZ͑̂B
				float moveSquareLength = move.x * move.x + move.z * move.z;
				float dp = mVelocity.dot( move );
				mVelocity.setMul( move, dp / moveSquareLength );
			}
			//B
			//ړx͍ő呬x/ԂłB
			float accel = mMaxMoveSpeed / static_cast< float >( mMoveAccelEndCount );
			mVelocity.madd( move, accel );
			//ő呬xŃXgbv
			float speed = mVelocity.length();
			if ( speed > mMaxMoveSpeed ){
				mVelocity *= mMaxMoveSpeed / speed;
			}
		}
	}
}

void Robo::draw() const {
	//`
	mModel->draw();
	//
	for ( int i = 0; i < mBulletNumber; ++i ){
		if ( !mBullets[ i ].isEmpty() ){
			mBullets[ i ].draw();
		}
	}
}

const Vector3* Robo::getPosition() const {
	return &mPosition;
}

void Robo::setDamage( int d ){
	mHitPoint -= d;
}

int Robo::getHitPoint() const {
	return mHitPoint;
}

int Robo::getEnergy() const {
	return mEnergy;
}

bool Robo::getLockOn() const {
	return mLockOn;
}

void Robo::getView( Matrix34* vm, Vector3* pos ) const {
	//܂ʕxN^쐬
	Vector3 d( 0.f, 0.f, 1.f );
	Matrix34 m;
	m.setRotationY( mAngleY );
	m.mul( &d, d );
	//OmCameraTargetDistanceZL΂
	Vector3 t;
	t.setMul( d, mCameraTargetDistanceZ );
	//{ƂɂȂ炿ƉĂB̓p[^ɂȂ̏HvB
	t.y -= mPosition.y * 0.12f; //̂ւ̒K
	//mCameraDistacneZL΂
	Vector3 p;
	p.setMul( d, -mCameraDistanceZ );
	//YmCameraDistanceYvX
	p.y += mCameraDistanceY;
	//{ƂɂȂ炿ƍڂɂĉĂB̓p[^ɂȂ̏HvB
	p.y += mPosition.y * 0.12f; //̂ւ̒K
	//{݈ʒuvX
	t += mPosition;
	p += mPosition;
	//r[s쐬
	vm->setViewTransform( p, t, Vector3( 0.f, 1.f, 0.f ) );
	*pos = p;
}
