#include "StdAfx.h"
#include "GameLib/GameLib.h"
#include "GameLib/Scene/CollisionMesh.h"
#include "GameLib/PseudoXml/Document.h"
#include "GameLib/PseudoXml/Element.h"
#include "GameLib/PseudoXml/Attribute.h"
#include "GameLib/Base/RefString.h"
#include "GameLib/Base/Impl/ReferenceType.h"
#include "GameLib/Base/Pool.h"
#include "GameLib/Math/Vector3.h"
#include "GameLib/Math/Functions.h"
using namespace std;
using namespace GameLib;
using namespace GameLib::PseudoXml;
using namespace GameLib::Math;

//#define STRONG_DEBUG //̍sĂk-d treeƑ̌ʂSɈv邩𖈉mFB
int G;

namespace{

//A֐BN[@ɂĉB
//| ax bx cx | | ox | = | dx |
//| ay by cy | | oy | = | dy |
//| az bz cz | | oz | = | dz |
//Ƃ`3xN^4󂯎A1ɉĕԂBo߂łB
//Â߂ɁAłxɔsāA͈͊OȂ瑦falseԂ
//trueԂ͓̂łB
bool solveLinearSystem(
Vector3* o,
const Vector3& a,
const Vector3& b,
const Vector3& c,
const Vector3& d ){
	float m1021 = a.y * b.z;
	float m1022 = a.y * c.z;

	float m1120 = b.y * a.z;
	float m1122 = b.y * c.z;

	float m1220 = c.y * a.z;
	float m1221 = c.y * b.z;

	//2ς̍OBs񎮗pAŎg܂킹B
	float m1122_m1221 = m1122 - m1221;
	float m1220_m1022 = m1220 - m1022; //}CiX
	float m1021_m1120 = m1021 - m1120;

	//s
	//00*( 11*22 - 12*21 ) - 01*( 10*22 - 12*20 ) + 02*( 10*21 - 11*20 )
	float delta = a.x*( m1122_m1221 ) + b.x*( m1220_m1022 ) + c.x*( m1021_m1120 );
	if ( delta == 0.f ){ //ȂBł͉Z덷͖A0ɂȂ݂̂͂B
		return false;
	}
	float rcpDelta = 1.f / delta;	
	
	//Z덷̖͋ɂ߂Ėʓ|łB
	//ł͌3ɂƂǂ܂ƍlAEPSILON*1000gB
	//3ɂ͓ς0.001ȉɂȂKvA0.05xȉ̕sB
	static const float zero = 0.f - EPSILON * 1000.f;
	static const float one = 1.f + EPSILON * 1000.f;

	//łtsɉEӃxN^悶vZBdeltȁZ͍ŌɍsB
	float m0221 = c.x * b.z;
	float m0122 = b.x * c.z;
	float m0112 = b.x * c.y;
	float m0211 = c.x * b.y;
	o->x = m1122_m1221 * d.x + ( m0221-m0122 ) * d.y + ( m0112-m0211 ) * d.z;
	//t̔sB
	o->x *= rcpDelta;
	if ( ( o->x < zero ) || ( o->x > one ) ){
		return false;
	}
	//uvZ
	float m0022 = a.x * c.z;
	float m0220 = c.x * a.z;
	float m0210 = c.x * a.y;
	float m0012 = a.x * c.y;
	o->y = m1220_m1022 * d.x + ( m0022-m0220 ) * d.y + ( m0210-m0012 ) * d.z;
	o->y *= rcpDelta;
	if ( o->y < zero ){
		return false;
	}
	//ŌvvZ
	float m0120 = b.x * a.z;
	float m0021 = a.x * b.z;
	float m0011 = a.x * b.y;
	float m0110 = b.x * a.y;
	o->z = m1021_m1120 * d.x + ( m0120-m0021 ) * d.y + ( m0011-m0110 ) * d.z;
	o->z *= rcpDelta;
	if ( o->z < zero ){
		return false;
	}
	//u,v̘a1ȉ`FbN
	if ( ( o->y + o->z ) > one ){
		return false;
	}
	return true;
}

struct Triangle{
	int mIndices[ 3 ];
};

//Փˏ肢鎞ɓńB炵ăI[o[wbh炷߂̋̍
struct Query{
	Query( 
	const Vector3& begin,
	const Vector3& vec,
	const Triangle* triangles,
	const Vector3* vertices ) :
	mBegin( begin ), mVector( vec ), mTriangles( triangles ), mVertices( vertices ){
	}
	~Query(){
		mTriangles = 0;
		mVertices = 0;
	}
	const Vector3& mBegin;
	const Vector3& mVector;
	const Triangle* mTriangles;
	const Vector3* mVertices;
private:
	void operator=( const Query& ); //Ȃ
};

//m[h\zۂbuild()ɓn炷߂̍\
class Node;
struct BuildArgs{
	BuildArgs( 
	const Triangle* triangles,
	const Vector3* vertices,
	Node* nodes,
	int triangleNumber ) :
	mTriangles( triangles ),
	mVertices( vertices ),
	mNodePos( nodes ),
	mIndexPool( triangleNumber ),
	mHitFlags( 0 ){
		mHitFlags = NEW bool[ triangleNumber * 2 ];
	}
	~BuildArgs(){
		SAFE_DELETE_ARRAY( mHitFlags );
		mTriangles = 0;
		mVertices = 0;
		mNodePos = 0;
	}

	const Triangle* mTriangles;
	const Vector3* mVertices;
	Node* mNodePos; //m[hz|C^
	Pool< int > mIndexPool; //CfNXmۗpv[
	bool* mHitFlags; //ꎞۊǗpqbgtÖ
private:
	void operator=( const BuildArgs& ); //Ȃ
};

bool getIntersectionTriangleAndLineSegment( 
float* tOut, 
const Query& q,
int index ){ //Op`CfNX
	const Triangle& tri = q.mTriangles[ index ];
	int i0 = tri.mIndices[ 0 ];
	int i1 = tri.mIndices[ 1 ];
	int i2 = tri.mIndices[ 2 ];
	const Vector3& p0 = q.mVertices[ i0 ];
	const Vector3& p1 = q.mVertices[ i1 ];
	const Vector3& p2 = q.mVertices[ i2 ];

	Vector3 minusD, minusE; //ӂ̋t
	Vector3 f;
	f.setSub( p0, q.mBegin ); 
	minusD.setSub( p0, p1 );
	minusE.setSub( p0, p2 );
	//ł͘AĈꔭŋ߂B{18.3.2QƂ̂ƁB
	//| bx -dx -ex | | ox | = | fx |
	//| by -dy -ey | | oy | = | fy |
	//| bz -dz -ez | | oz | = | fz |
	//bt+du+ev=p0-a ΗǂB
	Vector3 tuv; //
	if ( solveLinearSystem( &tuv, q.mVector, minusD, minusE, f ) ){
		*tOut = tuv.x; //tԂ
		return true;
	}else{
		return false; //O
	}
}

class Node{
public:
	struct InnerNode{ //m[h̃o
		float mLine; //
		Node* mLeft; //
		Node* mRight; //傫
	};
	struct OuterNode{ //[m[h̃oBOp`͖̂[m[hłB
		int* mIndices; //Op`ԍz
		int mIndexNumber;
	};
	Node() : mAxis( -1 ){
		mInner.mLine = 0.f;
		mInner.mLeft = mInner.mRight = 0;
		mOuter.mIndices = 0;
		mOuter.mIndexNumber = 0;
	}
	//ċA֐
	bool isIntersect( 
	const Query& q,
	float beginT, //a,b̓IWî܂܂ŁÃTCYɍ킹̂a'=a+beginT*b,b'=a+endT*b,ƌvZčsB
	float endT ) const {
		//O_łΒPɑ
		if ( mAxis == -1 ){ //-1͊O_̂邵
			for ( int i = 0; i < mOuter.mIndexNumber; ++i ){
				int triIdx = mOuter.mIndices[ i ];
++G;
				float dummyT;
				if ( getIntersectionTriangleAndLineSegment( &dummyT, q, triIdx ) ){ //IWiŔ肷B
					return true;
				}
			}
		}else{ //_B
			//ʖ
			const Vector3& a = q.mBegin;
			const Vector3& b = q.mVector;
			const Node* l = mInner.mLeft;
			const Node* r = mInner.mRight;
			//ʂɓ鎞߂B d = a + bt  t = ( d - a ) / b
			float divT;
			if ( b[ mAxis ] == 0.f ){ //0
				divT = FLOAT_MAX;
			}else{
				divT = ( mInner.mLine - a[ mAxis ] ) / b[ mAxis ];
			}
			float endT0, beginT1; //ŏɍsm[h̏I[Aɍsm[h̎n_
			if ( divT >= endT ){ //̃m[h܂œBȂ
				endT0 = endT;
				beginT1 = endT;
			}else if ( divT > beginT ){ //rŎ̃m[hɓ˓
				//Z덷ȂdivT̂܂ܓn΂A덷|̂łƂ肠\L߂ɎB
				endT0 = ( endT + divT * 15.f ) * ( 1.f / 16.f );
				beginT1 = ( beginT + divT * 15.f ) * ( 1.f / 16.f ); // 1/16n_ƏI_B0.001Ȃǂ𑫂Ɣ͈͂Ȃɗ[zĂ܂炾B
			}else{ //̃m[hւ͌Ȃ
				endT0 = endT;
				beginT1 = endT;
			}
			//n_߂B1vfŗǂ
			float begin = a[ mAxis ] + beginT * b[ mAxis ];
			//덷vZBgĂ鍀Ό덷͋@Bx̂܂܂łBbeginT͉ߏɗ]TĂB
			float e = Math::abs( a[ mAxis ] ) + Math::abs( beginT * b[ mAxis ] ) + Math::abs( mInner.mLine );
			e *= EPSILON * 10.f; //AÔ10{
			//n_:
			if ( begin + e < mInner.mLine ){
				if ( l && l->isIntersect( q, beginT, endT0 ) ){
					return true;
				}
				if ( beginT1 < endT ){
					if ( r && r->isIntersect( q, beginT1, endT ) ){
						return true;
					}
				}
			}else if ( begin - e > mInner.mLine ){ //n_:E
				if ( r && r->isIntersect( q, beginT, endT0 ) ){
					return true;
				}
				if ( beginT1 < endT ){
					if ( l && l->isIntersect( q, beginT1, endT ) ){
						return true;
					}
				}
			}else{ //ǂ킩ȂB
				//AP[XȂ̂ŎԔ͈͂͊ۂƂƂB
				if ( l && l->isIntersect( q, beginT, endT ) ){
					return true;
				}
				if ( r && r->isIntersect( q, beginT, endT ) ){
					return true;
				}
			}
		}
		return false;
	}
	//ċA֐B߂l͎Op`ԍ
	void getIntersection(
	int* minIndex, //ŏœOp`ԍ
	float* minT, //ŏ
	const Query& q,
	float beginT, //a,b̓IWî܂܂ŁÃTCYɍ킹̂a'=a+beginT*b,b'=a+endT*b,ƌvZčsB
	float endT ) const {
		//O_łΒPɑ
		if ( mAxis == -1 ){ //-1͊O_̂邵
			for ( int i = 0; i < mOuter.mIndexNumber; ++i ){
				int triIdx = mOuter.mIndices[ i ];
++G;
				float t;
				if ( getIntersectionTriangleAndLineSegment( &t, q, triIdx ) ){ //IWiŔ肷B
					if ( t < *minT ){
						*minT = t; //XV
						*minIndex = triIdx;
					}
				}
			}
		}else{ //_B
			//ʖ
			const Vector3& a = q.mBegin;
			const Vector3& b = q.mVector;
			const Node* l = mInner.mLeft;
			const Node* r = mInner.mRight;
			//ʂɓ鎞߂B d = a + bt  t = ( d - a ) / b
			float divT;
			if ( b[ mAxis ] == 0.f ){ //0
				divT = FLOAT_MAX;
			}else{
				divT = ( mInner.mLine - a[ mAxis ] ) / b[ mAxis ];
			}
			float endT0, beginT1; //ŏɍsm[h̏I[Aɍsm[h̎n_
			if ( divT >= endT ){ //̃m[h܂œBȂ
				endT0 = endT;
				beginT1 = endT;
			}else if ( divT > beginT ){ //rŎ̃m[hɓ˓
				//Z덷ȂdivT̂܂ܓn΂A덷|̂łƂ肠\L߂ɎB
				endT0 = ( endT + divT * 15.f ) * ( 1.f / 16.f );
				beginT1 = ( beginT + divT * 15.f ) * ( 1.f / 16.f ); // 1/16n_ƏI_
			}else{ //̃m[hւ͌Ȃ
				endT0 = endT;
				beginT1 = endT;
			}
			//n_߂B1vfŗǂ
			float begin = a[ mAxis ] + beginT * b[ mAxis ];
			//덷vZBgĂ鍀Ό덷͋@Bx̂܂܂łB
			float e = Math::abs( a[ mAxis ] ) + Math::abs( beginT * b[ mAxis ] ) + Math::abs( mInner.mLine );
			e *= EPSILON * 10.f; //AÔ10{
			//n_:
			if ( begin + e < mInner.mLine ){
				if ( l ){
					l->getIntersection( minIndex, minT, q, beginT, endT0 );
				}
				if ( beginT1 < endT ){
					if ( r ){
						r->getIntersection( minIndex, minT, q, beginT1, endT );
					}
				}
			}else if ( begin - e > mInner.mLine ){ //n_:E
				if ( r ){
					r->getIntersection( minIndex, minT, q, beginT, endT0 );
				}
				if ( beginT1 < endT ){
					if ( l ){
						l->getIntersection( minIndex, minT, q, beginT1, endT );
					}
				}
			}else{ //ǂ킩ȂB
				//AP[XȂ̂ŎԔ͈͂͊ۂƂƂB
				if ( l ){
					l->getIntersection( minIndex, minT, q, beginT, endT );
				}
				if ( r ){
					r->getIntersection( minIndex, minT, q, beginT, endT );
				}
			}
		}
	}
	//ċA\z֐
	/*
	̍ہǍvZɂ͌덷A덷݂ŏo̗pB
	܂A0.5ɂȂׂ0.51ɂȂ̂ł΁A0.51𕪊ƂB
	Ƃĉg̓ASYCӂłB
	ĎOp`̒_W͌f[^ƂĈA덷͉̍肵ȂB
	AOp`̍WɊւĂ͔rȊỎZs킸덷͍ȂB
	āAeOp`ɑ΂čEǂɂ邩͌Ɍ덷lɌ߂Ă悢B
	ȂAɌɏOp`́uEɂvƂB
	*/
	void build(
	const Vector3& minV, //͈͍ŏl
	const Vector3& maxV, //͈͍ől
	BuildArgs* args,
	int restLevel ){ //Ɖ񕪊邩
		//ŏOuterg
		OuterNode* outer = &mOuter;

		//ŗǂ̕ǂ߂邩͓肾Ał͍łBꂪϓIɂ͑ÓȌʂoB
		int axis = -1; //
		Vector3 size;
		size.setSub( maxV, minV );
		float maxSize = -FLOAT_MAX;
		for ( int i = 0; i < 3; ++i ){
			if ( size[ i ] > maxSize ){
				maxSize = size[ i ];
				axis = i;
			}
		}
		//
		float div;
		div = minV[ axis ] + maxV[ axis ];
		div *= 0.5f;
		//茋ʂ͌ŎĝboolzɕێĂB̈newƒx̂ŁAłĂB
		bool* hitL = args->mHitFlags;
		bool* hitR = hitL + outer->mIndexNumber;
		//E̎Op`
		int cl = 0;
		int cr = 0;
		//ǂɑ
		const Triangle* triangles = args->mTriangles;
		const Vector3* vertices = args->mVertices;
		for ( int i = 0; i < outer->mIndexNumber; ++i ){ //eOp`ɂĒׂ
			const Triangle& tri = triangles[ outer->mIndices[ i ] ];
			const Vector3& p0 = vertices[ tri.mIndices[ 0 ] ];
			const Vector3& p1 = vertices[ tri.mIndices[ 1 ] ];
			const Vector3& p2 = vertices[ tri.mIndices[ 2 ] ];
			//ɂčŏő擾
			float minP, maxP;
			minP = min( p0[ axis ], p1[ axis ] );
			minP = min( minP, p2[ axis ] );
			maxP = max( p0[ axis ], p1[ axis ] );
			maxP = max( maxP, p2[ axis ] );

			hitL[ i ] = ( minP < div ); //炩ɍɏ 덷lĂȂR͊֐̑OɂRgQƂ̂ƁB
			hitR[ i ] = ( maxP > div ); //炩ɉEɏ
			//҂łꍇB̏ꍇEɏBɏƂԂ邩炾B
			//덷̍l͔莞ɍsB
			if ( ( minP == maxP ) && ( minP == div ) ){
				hitR[ i ] = true;
			}
			if ( hitL[ i ] ){
				++cl;
			}
			if ( hitR[ i ] ){
				++cr;
			}
		}
		//Jn
		//InnerNodeɕςBOuterNodẽo͈U[Jϐɑޔ
		//union͓̂ł܂ׂł͂ȂA\̗RΎd܂B
		int* indices = outer->mIndices;
		int indexNumber = outer->mIndexNumber;
		outer->mIndices = 0;
		outer->mIndexNumber = 0;
		outer = 0; //ȍ~Outer͂Ȃ

		InnerNode* inner = &mInner; //ȍ~inner݂̂ɃANZX

		//mAxis-1ȊOĂ邱ƂInnerNodeł邵邵B
		mAxis = axis; //axis==0Ȃ炻̂܂܁A1ȂYA2ȂZɂȂ
		inner->mLine = div; //

		//Em[h̊m
		if ( cl > 0 ){ //Op`
			inner->mLeft = args->mNodePos;
#ifdef STRONG_DEBUG
Vector3 boxDiv = maxV;
boxDiv[ axis ] = div;
inner->mLeft->mMin = minV;
inner->mLeft->mMax = boxDiv;
inner->mLeft->mOrigN = cl;
#endif
			++( args->mNodePos );
			inner->mLeft->mOuter.mIndices = args->mIndexPool.allocate( cl );
		}
		if ( cr > 0 ){
			inner->mRight = args->mNodePos;
#ifdef STRONG_DEBUG
Vector3 boxDiv = minV;
boxDiv[ axis ] = div;
inner->mRight->mMin = boxDiv;
inner->mRight->mMax = maxV;
inner->mRight->mOrigN = cr;
#endif
			++( args->mNodePos );
			inner->mRight->mOuter.mIndices = args->mIndexPool.allocate( cr );
		}
		//Em[hɐU蕪B
		for ( int i = 0; i < indexNumber; ++i ){ //eOp`ɂĒׂ
			if ( hitL[ i ] ){
				OuterNode* l = &inner->mLeft->mOuter;
				l->mIndices[ l->mIndexNumber ] = indices[ i ];
				++( l->mIndexNumber );
			}
			if ( hitR[ i ] ){
				OuterNode* r = &inner->mRight->mOuter;
				r->mIndices[ r->mIndexNumber ] = indices[ i ];
				++( r->mIndexNumber );
			}
		}
		//qbgtÖg܂킷֌WŁAċAĂяo͐U蕪IĂB
		if ( restLevel > 1 ){ //ŏIx͂Ă΂Ȃ
			if ( cl > 1 ){
				Vector3 boxDiv = maxV;
				boxDiv[ axis ] = div;
				inner->mLeft->build( minV, boxDiv, args, restLevel - 1 );
			}
			if ( cr > 1 ){
				Vector3 boxDiv = minV;
				boxDiv[ axis ] = div;
				inner->mRight->build( boxDiv, maxV, args, restLevel - 1 );
			}
		}
	}
	void count( int* nodeNumber, int* indexNumber ){
		++( *nodeNumber ); //̕Z
		if ( mAxis != -1 ){
			if ( mInner.mLeft ){
				mInner.mLeft->count( nodeNumber, indexNumber );
			}
			if ( mInner.mRight ){
				mInner.mRight->count( nodeNumber, indexNumber );
			}
		}else{
			*indexNumber += mOuter.mIndexNumber;
		}		
	}
	Node* copy( Node** nodePos, int** indexPos ){
		Node* to = *nodePos; //Rs[
		++( *nodePos );
#ifdef STRONG_DEBUG
to->mMin = mMin;
to->mMax = mMax;
to->mOrigN = mOrigN;
#endif
		to->mAxis = mAxis;
		if ( mAxis != -1 ){ //m[h̏ꍇ
			to->mInner.mLine = mInner.mLine;
			if ( mInner.mLeft ){
				to->mInner.mLeft = mInner.mLeft->copy( nodePos, indexPos );
			}
			if ( mInner.mRight ){
				to->mInner.mRight = mInner.mRight->copy( nodePos, indexPos );
			}
		}else{ //CfNXm
			to->mOuter.mIndices = *indexPos;
			//CfNXRs[
			for ( int i = 0; i < mOuter.mIndexNumber; ++i ){
				to->mOuter.mIndices[ i ] = mOuter.mIndices[ i ];
			}
			to->mOuter.mIndexNumber = mOuter.mIndexNumber;
			( *indexPos ) += mOuter.mIndexNumber;
		}
		return to;
	}
	//̖̕ʂȃm[h폜B͈̂ȉ3
	//1.O_ŉEB̓eɈグB
	//2.EO_ōBE̓eɈグB
	//3.EO_ŎOp`XgBqĎɃRs[B
	void optimize(){
		if ( mAxis == -1 ){ //O_Ȃ珈ȂBIB
			return;
		}
		Node* l = mInner.mLeft;
		Node* r = mInner.mRight;
		//܂ċAĂяo
		if ( l ){
			l->optimize();
		}
		if ( r ){
			r->optimize();
		}
		bool lIsOuter = ( l && ( l->mAxis == -1 ) );
		bool rIsOuter = ( r && ( r->mAxis == -1 ) );
		OuterNode* o = 0; //グO_΂ɓB
		if ( lIsOuter && !r ){ //O_ŉEB
			o = &l->mOuter;
		}else if ( rIsOuter && !l ){ //EO_ō
			o = &r->mOuter;
		}else if ( lIsOuter && rIsOuter ){ //`FbN
			OuterNode* lo = &l->mOuter;
			OuterNode* ro = &r->mOuter;
			bool match = true;
			if ( lo->mIndexNumber == ro->mIndexNumber ){
				for ( int i = 0; i < lo->mIndexNumber; ++i ){
					if ( lo->mIndices[ i ] != ro->mIndices[ i ] ){
						match = false;
					}
				}
				if ( match ){ //S}b`BɈグB
					o = lo;
				}
			}
		}
		if ( o ){ //グ񂠂BO_ɂB
			mAxis = -1;
			mInner.mLeft = mInner.mRight = 0;
			mOuter.mIndexNumber = o->mIndexNumber;
			mOuter.mIndices = o->mIndices;
		}
	}
	void checkTriangleIndexExistance( Array< bool >& f ){
		if ( mAxis == -1 ){
			for ( int i = 0; i < mOuter.mIndexNumber; ++i ){
				f[ mOuter.mIndices[ i ] ] = true;
			}
		}else{
			if ( mInner.mLeft ){
				mInner.mLeft->checkTriangleIndexExistance( f );
			}
			if ( mInner.mRight ){
				mInner.mRight->checkTriangleIndexExistance( f );
			}
		}
	}
	void checkTriangle( const Triangle* triangles, const Vector3* vertices ) const {
		if ( mAxis == -1 ){ //_̂݃`FbN
			return;
		}
		if ( mInner.mLeft ){
			if ( mInner.mLeft->mAxis == -1 ){
				const OuterNode& o = mInner.mLeft->mOuter;
				for ( int i = 0; i < o.mIndexNumber; ++i ){
					int triIdx = o.mIndices[ i ];
					const Triangle& tri = triangles[ triIdx ];
					bool hit = false;
					for ( int j = 0; j < 3; ++j ){
						const Vector3& p = vertices[ tri.mIndices[ j ] ];
						for ( int k = 0; k < 3; ++k ){
							if ( p[ k ] < mInner.mLine ){
								hit = true;
							}
						}
					}
					STRONG_ASSERT( hit );
				}
			}else{
				mInner.mLeft->checkTriangle( triangles, vertices );
			}
		}
		if ( mInner.mRight ){
			if ( mInner.mRight->mAxis == -1 ){
				const OuterNode& o = mInner.mRight->mOuter;
				for ( int i = 0; i < o.mIndexNumber; ++i ){
					int triIdx = o.mIndices[ i ];
					const Triangle& tri = triangles[ triIdx ];
					bool hit = false;
					for ( int j = 0; j < 3; ++j ){
						const Vector3& p = vertices[ tri.mIndices[ j ] ];
						for ( int k = 0; k < 3; ++k ){
							if ( p[ k ] >= mInner.mLine ){
								hit = true;
							}
						}
					}
					STRONG_ASSERT( hit );
				}
			}else{
				mInner.mRight->checkTriangle( triangles, vertices );
			}
		}
	}
#ifdef STRONG_DEBUG
Vector3 mMin; //foOp
Vector3 mMax;
int mOrigN;
#endif
	int mAxis; //B0:X, 1:Y, 2:Z, -1OuterNodeB
	union{ //union̒̓LB[Ɠł͕KvȃoႤ̂Ő\̂߂ɂĂB
		InnerNode mInner;
		OuterNode mOuter;
	};
};

} //namespace{}

namespace GameLib{
namespace Scene{

class CollisionMesh::Impl : public ReferenceType {
public:
	explicit Impl( const char* filename ) :
	mVertices( 0 ), 
	mVertexNumber( 0 ),
	mTriangles( 0 ),
	mTriangleNumber( 0 ),
	mNodes( 0 ),
	mIndicesInNode( 0 ){
		mDocument = Document::create( filename );
	}
	explicit Impl( ConstElement e ) : 
	mVertices( 0 ), 
	mVertexNumber( 0 ),
	mTriangles( 0 ),
	mTriangleNumber( 0 ),
	mNodes( 0 ),
	mIndicesInNode( 0 ){
		createFromElement( e );
	}
	~Impl(){
		SAFE_DELETE_ARRAY( mVertices );
		SAFE_DELETE_ARRAY( mTriangles );
		SAFE_DELETE_ARRAY( mNodes );
		SAFE_DELETE_ARRAY( mIndicesInNode );
	};
	void createFromElement( ConstElement e ){
		//pXB_AOp`𐔂B
		int n = e.childNumber();
		for ( int i = 0; i < n; ++i ){
			ConstElement child = e.child( i );
			RefString name( child.name() );
			if ( name == "VertexBuffer" ){
				mVertexNumber += child.childNumber();
			}else if ( name == "IndexBuffer" ){
				mTriangleNumber += child.childNumber();
			}
		}
		//m
		mVertices = NEW Vector3[ mVertexNumber ];
		mTriangles = NEW Triangle[ mTriangleNumber ];
		//pXB_[U
		int vertexPos = 0;
		int trianglePos = 0;
		for ( int i = 0; i < n; ++i ){
			ConstElement child = e.child( i );
			RefString name( child.name() );
			if ( name == "VertexBuffer" ){
				vertexPos = fillVertices( child, vertexPos );
			}else if ( name == "IndexBuffer" ){
				trianglePos = fillTriangles( child, trianglePos );
			}
		}
		//OpXk-d tree
		buildKDTree();
	}
	void buildKDTree(){
		//m[h͎Op`zI1Âi[ꂽƉ肵Ƃ܂Ŋ鐔pӂB
		//Op`tnȏŏ2̙p߁A̓{pӂ΂悢B
		int tn = mTriangleNumber;
		int maxNodeNumber = 1;
		int maxLevel = 0; //ő啪
		while ( maxNodeNumber < tn ){
			maxNodeNumber <<= 1;
			++maxLevel;
		}
		Node* tmpNodes = NEW Node[ maxNodeNumber * 2 ];
		//\̏
		BuildArgs args( mTriangles, mVertices, tmpNodes, mTriangleNumber );

		Node root;
		//Op`ԍ[U
		root.mOuter.mIndices = args.mIndexPool.allocate( mTriangleNumber );
		root.mOuter.mIndexNumber = mTriangleNumber;
		for ( int i = 0; i < mTriangleNumber; ++i ){
			root.mOuter.mIndices[ i ] = i;
		}
		//ẼTCY𑪒BXYZ̍őŏ𒲂ׂB
		Vector3 minV( FLOAT_MAX ); //őŏ
		Vector3 maxV( -minV.x ); //ŏŏ
		for ( int i = 0; i < mVertexNumber; ++i ){
			minV.min( mVertices[ i ] ); //minXYZōŏlĎɓB
			maxV.max( mVertices[ i ] ); //maxXYZōőlĎɓB
		}
		root.build( minV, maxV, &args, maxLevel );
#ifdef STRONG_DEBUG
root.mMin = minV;
root.mMax = maxV;
#endif
		root.optimize(); //pȃm[hĐ\グB
		//ɕKvȗ̈𑪒肵āAŒ肵̈ɃRs[B
		int indexNumber = 0;
		int nodeNumber = 0;
		root.count( &nodeNumber, &indexNumber );
		mIndicesInNode = NEW int[ indexNumber ];
		mNodes = NEW Node[ nodeNumber ];
		//Sm[hRs[
		Node* nodePos = mNodes;
		int* indicesPos = mIndicesInNode;
		root.copy( &nodePos, &indicesPos );
		//n
		SAFE_DELETE_ARRAY( tmpNodes );
#ifdef STRONG_DEBUG
		Array< bool > triangleExistFlags( mTriangleNumber );
		for ( int i = 0; i < mTriangleNumber; ++i ){
			triangleExistFlags[ i ] = false;
		}
		mNodes[ 0 ].checkTriangleIndexExistance( triangleExistFlags );
		for ( int i = 0; i < mTriangleNumber; ++i ){
			STRONG_ASSERT( triangleExistFlags[ i ] );
		}
		mNodes[ 0 ].checkTriangle( mTriangles, mVertices );
#endif
	}
	bool isReady(){
		bool ok = true;
		if ( mDocument ){
			if ( mDocument.isReady() ){
				ConstElement e = mDocument.root();
				//qlŖOContainer̎ɌāAqnB
				if ( ( e.childNumber() == 1 ) && ( RefString( "Container" ) != e.name() ) ){
					e = e.child( 0 );
				}
				createFromElement( e );
				e.release(); //ɔjB
				mDocument.release();
			}else{
				ok = false;
			}
		}
		return ok;
	}
	bool isIntersect( const Vector3& a, const Vector3& b ) const {
		Query q( a, b, mTriangles, mVertices );
		bool ret = mNodes[ 0 ].isIntersect( q, 0.f, 1.f );
#ifdef STRONG_DEBUG //rp
		bool retCheck = false;
		for ( int i = 0; i < mTriangleNumber; ++i ){
			float dummyT;
			if ( getIntersectionTriangleAndLineSegment( &dummyT, q, i ) ){
				retCheck = true;
			}
		}
		STRONG_ASSERT( ret == retCheck );
#endif
		return ret;
	}
	bool getIntersection(
	float* tOut,
	Vector3* nOut,
	const Vector3& a,
	const Vector3& b ) const {
G = 0;
		float t = FLOAT_MAX; //o
		int index = -1;
		Query q( a, b, mTriangles, mVertices );
		mNodes[ 0 ].getIntersection( &index, &t, q, 0.f, 1.f );
#ifdef STRONG_DEBUG //rp
		int indexCheck = -1;
		float tCheck = FLOAT_MAX;
		for ( int i = 0; i < mTriangleNumber; ++i ){
			float tmpT;
			if ( getIntersectionTriangleAndLineSegment( &tmpT, q, i ) ){
				if ( tmpT < tCheck ){
					tCheck = tmpT;
					indexCheck = i;

				}
			}
		}
		STRONG_ASSERT( t == tCheck ); //index͍ȂƂB
#endif
		if ( index != -1 ){
			//ŏIIɓOp`̏i[
			if ( tOut ){
				*tOut = t;
			}
			if ( nOut ){
				int i0 = mTriangles[ index ].mIndices[ 0 ];
				int i1 = mTriangles[ index ].mIndices[ 1 ];
				int i2 = mTriangles[ index ].mIndices[ 2 ];
				const Vector3& p0 = mVertices[ i0 ];
				const Vector3& p1 = mVertices[ i1 ];
				const Vector3& p2 = mVertices[ i2 ];
				Vector3 e0, e1; //Edge(=)
				e0.setSub( p1, p0 );
				e1.setSub( p2, p0 );
				nOut->setCross( e0, e1 );
				nOut->normalize();
			}
			return true;
		}else{
			return false;
		}
	}
private:
	int fillVertices( ConstElement vb, int pos ){
		int n = vb.childNumber();
		RefString positionStr( "position" );
		for ( int i = 0; i < n; ++i ){
			ConstElement v = vb.child( i );
			int an = v.attributeNumber();
			for ( int j = 0; j < an; ++j ){
				ConstAttribute a = v.attribute( j );
				if ( positionStr == a.name() ){
					a.getFloatValues( &mVertices[ pos ].x, 3 );
					++pos;
				}
			}
		}
		return pos;
	}
	int fillTriangles( ConstElement ib, int pos ){
		int n = ib.childNumber();
		for ( int i = 0; i < n; ++i ){
			ConstElement t = ib.child( i );
			ASSERT( t.attributeNumber() > 0 && "IndexBuffer : It's not valid element." );
			ConstAttribute a = t.attribute( 0 );
			a.getIntValues( mTriangles[ pos ].mIndices, 3 );
			++pos;
		}
		return pos;
	}
	Document mDocument;
	Vector3* mVertices;
	int mVertexNumber;
	Triangle* mTriangles;
	int mTriangleNumber;
	Node* mNodes; //0Ԃ
	int* mIndicesInNode; //m[hCfNXez
};

CollisionMesh::CollisionMesh( Impl* impl ) : mImpl( impl ){
	if ( mImpl ){
		mImpl->refer();
	}
}

CollisionMesh CollisionMesh::create( const char* filename ){
	CollisionMesh r;
	r.mImpl = NEW Impl( filename );
	return r;
}

CollisionMesh CollisionMesh::create( ConstElement e ){
	CollisionMesh r;
	r.mImpl = NEW Impl( e );
	return r;
}

bool CollisionMesh::isIntersect( const Vector3& a, const Vector3& b ) const {
	return mImpl->isIntersect( a, b );
}

bool CollisionMesh::getIntersection(
float* t,
Vector3* n,
const Vector3& a,
const Vector3& b ) const {
	return mImpl->getIntersection( t, n, a, b );
}

bool CollisionMesh::isReady(){
	return mImpl->isReady();
}

#define TYPE CollisionMesh
#include "GameLib/Base/Impl/ReferenceTypeTemplate.h"

} //namespace Scene
}//namespace GameLib